﻿Public Class Filter_FIR

    Private mCoeffs() As Double
    Private mNumCoeffs As Int32
    Private mHistory() As Double
    Private mCurrentIndex As Int32

    Friend Sub Init(ByVal Coeffs() As Double)
        mCoeffs = Coeffs
        mNumCoeffs = mCoeffs.Length
        mCurrentIndex = 0
        ReDim mHistory(mNumCoeffs - 1)
    End Sub

    Friend Function NewSample(ByVal value As Double) As Double
        mHistory(mCurrentIndex) = value
        mCurrentIndex += 1
        If mCurrentIndex = mNumCoeffs Then mCurrentIndex = 0
        Dim index As Integer = mCurrentIndex
        Dim output As Double = 0
        For i As Int32 = 0 To mNumCoeffs - 1
            If index <> 0 Then
                index -= 1
            Else
                index = mNumCoeffs - 1
            End If
            output += mHistory(index) * mCoeffs(i)
        Next
        Return output
    End Function

End Class
